<script setup lang="ts">
import { nextTick, ref, onMounted } from 'vue';

import type { VForm } from 'vuetify/components';
import type { User } from '@/types/User';

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Email',
    key: 'email',
    value: 'email'
  },
  {
    title: 'Full Name',
    key: 'fullName',
    value: 'fullName'
  },
  {
    title: 'Gender',
    key: 'gender',
    value: 'gender'
  },
  {
    title: 'Roles',
    key: 'roles',
    value: (item: any | User) => item.roles.join(', ')
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initialUser: User = {
  id: -1,
  email: '',
  password: '',
  fullName: '',
  gender: 'male',
  roles: ['user'],
  workTime: 0,
  workRate: 0,
  date: '',
  checkIN: "",
  checkOUT: "",
  isCheckedIn: false,
  isCheckedOut: false
}
const editedUser = ref<User>(JSON.parse(JSON.stringify(initialUser)))
const users = ref<User[]>([])
let editedIndex = -1
let lastId = 4
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
  })
}
function deleteItemConfirm() {
  users.value.splice(editedIndex, 1)
  closeDelete()
}
function deleteItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
}
function editItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId++
    users.value.push(editedUser.value)
  }
  editedIndex = -1
  closeDialog()
}
function initialize() {
  users.value = [{
    id: 1,
    email: 'admin',
    password: 'Pass@Word123',
    fullName: 'Admin',
    gender: 'male',
    roles: ['admin', 'user'],
    workTime: 0,
    workRate: 30,
    date: "Jan-10-2024",
    checkIN: "08.00",
    checkOUT: "16.00",
    isCheckedIn: false,
    isCheckedOut: true,

  },
  {
    id: 2,
    email: 'user1',
    password: 'Pass@Word123',
    fullName: 'User1',
    gender: 'female',
    roles: ['user'],
    workTime: 0,
    workRate: 35,
    date: "Jan-11-2024",
    checkIN: "08.00",
    checkOUT: "16.00",
    isCheckedIn: false,
    isCheckedOut: true,

  },
  {
    id: 3,
    email: 'user2',
    password: 'Pass@Word123',
    fullName: 'User2',
    gender: 'male',
    roles: ['user'],
    workTime: 0,
    workRate: 25,
    date: "Jan-12-2024",
    checkIN: "08.00",
    checkOUT: "16.00",
    isCheckedIn: false,
    isCheckedOut: true,

  }]
}

onMounted(() => {
  initialize()
})
</script>
<template>
   
    <div style="margin-bottom: 21%;">
        <v-data-table :headers="headers" :items="users" >
        <template v-slot:top>
      <v-toolbar flat style="background-color: rgba(97, 63, 45, 0.867);">
        <v-toolbar-title style="color: rgba(255, 255, 255, 0.867);">Users</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
        
        
    <v-dialog
      v-model="dialog"
      persistent
      width="1024"
    >
      <template v-slot:activator="{ props }">
        <v-btn style="background-color: rgb(216, 201, 201); width: 150px; height: 45px" class="mr-4"
          color="black"
          v-bind="props"
        >
          New User
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">User Profile</span>
        </v-card-title>
        <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                    <v-row>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.email"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Email"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.fullName"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Full Name"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.password"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="Password"
                            placeholder="Enter your password"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="6">
                            <v-combobox 
                              label="Gender" 
                              :items="['male', 'female', 'others']" 
                              v-model="editedUser.gender"
                            ></v-combobox>
                        </v-col>
                        <v-col cols="12" sm="6">
                            <v-combobox
                              v-model="editedUser.roles"
                              :items="[
                                { title: 'Admin', value: 'admin' },
                                { title: 'User', value: 'user' }]"
                              label="Select roles"
                              :return-object="false"
                            ></v-combobox>
                        </v-col>
                    </v-row>
                
                </v-container>

      </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4" color="blue-darken-5" variant="text" @click="closeDialog">Close</v-btn>
          <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4" color="blue-darken-5" variant="text" @click="save()">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  
        <!-- Delete Dialog -->
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
        </template>
        <template v-slot:[`item.actions`]="{ item }">
      <v-icon
      color="blue-darken-1"
        size="small"
        class="me-2"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
      color="red-accent-4"
        size="small"
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn
        color="primary"
        @click="initialize"
      >
        Reset
      </v-btn>
    </template>
        </v-data-table>
    </div>
    
    
</template>
